# -*- coding: utf-8 -*-

#4a) Per caratterizzare la collocazione di sottostringhe palindrome in una 
# sequenza di DNA, si faccia ricorso a un albero definito come segue.
# Un nodo dell'albero (v. codice riportato) corrisponde a una porzione di 
# sequenza; esso contiene i seguenti campi: 
# "start" e "end", indici in cui, nella sequenza globale, rispettivamente 
# inizia e termina tale porzione (convenzione Python);
# "palindex", con l'indice da cui inizia (eventualmente) l'UNICO palindromo 
# presente nella porzione;
# "first" e "second", che eventualmente riferiscono rispettivamente la 
# prima e la seconda semi-stringa, qualora contengano uno o più palindromi 
# (altrimenti contengono None).
# In una stringa s, per prima semi-stringa si intende s[:len(s)/2], e per 
# seconda la s[len(s)/2:].
# La radice dell'albero corrisponderà alla sequenza completa.
#
# Si definisca una funzione buildPalTree che, data una stringa s e l'intero k, 
# costruisca l'albero dei palindromi lunghi k e ne restituisca la radice.
#
# Es: s="CTAATCGG"
#     print findPal(s,3)  --> [1, 2, 5] 
#     r=buildTree(s,k=3)
#     print r.to_string() --> (0 . (0 . (0 P1 * * 2) (2 P2 * * 4) 4) (4 P5 * * 8) 8)


class NodePT(object):
    def __init__(self, start=0, end=0, palindex=None, first=None, second=None):
        self.start = start
        self.end = end
        self.palindex  = palindex
        self.first = first
        self.second = second

    def to_string(self):
        sout='('+str(self.start)
        if self.palindex is None:
            sout+=' .'
        else:
            sout+=' P'+str(self.palindex)
        if self.first is None:
            sout+=' *'
        else:
            sout+=' '+self.first.to_string()
        if self.second is None:
            sout+=' *'
        else:
            sout+=' '+self.second.to_string()
        sout+=' '+str(self.end)+')'
        return sout


from soluzione2 import findPal

def buildTree(dnaseq, k=8, firstindex=0, palindromes=None):

    ls=len(dnaseq)
    root=NodePT(start=firstindex, end=firstindex+ls)
    
    if palindromes is None:
        palindromes=findPal(dnaseq, k)    
    if not palindromes:
        return root
    l=len(palindromes)
    if l==1:
        root.palindex=palindromes[0]
        return root
    
    #palindromes in the first halfstring
    firstset = [i for i in palindromes if i<firstindex+ls/2]
    #palindromes in the second halfstring
    secondset = [i for i in palindromes if i>=firstindex+ls/2] 

    if firstset:
        root.first =buildTree(dnaseq[:ls/2],k,firstindex,palindromes=firstset)
    if secondset:
        root.second=buildTree(dnaseq[ls/2:],k,firstindex+ls/2,palindromes=secondset)
        
    return root
        